#include "collisions.h"

void Collisions::
resolve_inelastic_particle_collisions(float collision_dt, const std::vector<Vec3f> &oldx,
                                      std::vector<Vec3f > &x, std::vector<Vec3f > &v)
{
   // just loop over all the particles, doing each one individually
   for(unsigned int i=0; i<oldx.size(); ++i)
      resolve_inelastic_collision(collision_dt, oldx[i], x[i], v[i]);
}

void Collisions::
resolve_inelastic_collision(float collision_dt, const Vec3f &oldx, Vec3f &x, Vec3f &v)
{
   // @@@ You will need to fill in the code, as described in class, for processing a collision.
   // @@@   oldx is the previous particle position
   // @@@   x is the possible new position (before collision checks)
   // @@@   v is the particle velocity (NOT the average velocity)
   // @@@   collision_dt is the time step over which this takes place
   // @@@ Check if x has collided with the heightfield. If so, find the normal and the average
   // @@@ velocity, solve for the new velocity, and update x and v appropriately. Loop until no
   // @@@ collisions remain, to a maximum of 5 iterations, at which point you should use a failsafe
   // @@@ method to get x outside the collision geometry.

}

