#ifndef SPARSEARRAY3_H
#define SPARSEARRAY3_H

#include "hashtable.h"
#include "inttuples.h"

struct SparseArray3
{
   HashTable<IntTuple<3>, float> A;
   const float zero;

   SparseArray3()
      : zero(0)
   {}

   float &operator() (int i, int j, int k)
   { return A(IntTuple<3>(i,j,k), 0); }

   const float &operator() (int i, int j, int k) const
   { return A(IntTuple<3>(i,j,k), zero); }
};

#endif
